//+------------------------------------------------------------------+
//|                      lukas1 arrows & curves.mq4       v.14       |
//|       :                                                 | 
//|       1.   () ,      |
//|            Kmin, Kmax, RISK                             |
//|       2.                  |
//|            ,    .    |
//|       3.   .                             |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, lukas1"
#property link      "http://www.alpari-idc.ru/"
//----
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Green

//
extern string TimeFrame       = "Current time frame";
extern int    SSP             = 6;     //   
extern int    SkyCh           = 13;    //    
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   Interpolate     = true;

//
//
//
//
//

double val1[];      //   
double val2[];      //   
double Sky_BufferH[];
double Sky_BufferL[];
int    timeFrame;
bool   returnBars;
bool   calculateValue;
string indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, val1); SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0,233); SetIndexDrawBegin(0, 2*SSP);SetIndexLabel(0, "Luk-Up-arrow");
   SetIndexBuffer(1, val2); SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1,234); SetIndexDrawBegin(1, 2*SSP);SetIndexLabel(1, "Luk-Dwn-arrow");
   SetIndexBuffer(2, Sky_BufferH); SetIndexLabel(2, "Luk-High"); SetIndexDrawBegin(2, 2*SSP);
   SetIndexBuffer(3, Sky_BufferL); SetIndexLabel(3, "Luk-Low");  SetIndexDrawBegin(3, 2*SSP);
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][1];
#define _uptrend 0

int start()
{   
   int i,r,counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
             int limit=MathMin(Bars-counted_bars,Bars-1);
             if (returnBars) { val1[0] = limit; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      GlobalVariableSet("goSELL", 0); //     goSELL=0
      GlobalVariableSet("goBUY", 0);  //     goBUY =0
      if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

      //
      //
      //
      //
      //
      
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      { 
         double high = High[ArrayMaximum(High,SSP,i)]; 
         double low  = Low[ ArrayMinimum(Low ,SSP,i)]; 
         double smax = high - (high - low)*SkyCh / 100;
         double smin = low  + (high - low)*SkyCh / 100;
            val1[i] = EMPTY_VALUE;  
            val2[i] = EMPTY_VALUE;
            work[r][_uptrend] = work[r-1][_uptrend];
               if(Close[i] < smin && i!=0 ) work[r][_uptrend] = false;
	            if(Close[i] > smax && i!=0 ) work[r][_uptrend] = true;
               if(work[r][_uptrend] != work[r-1][_uptrend] && work[r][_uptrend] == false)
               {
                  val2[i] = high; if(i == 0) GlobalVariableSet("goBUY",1);
               }
               if(work[r][_uptrend] != work[r-1][_uptrend] && work[r][_uptrend] == true)
               {
                 val1[i] = low; if(i == 0)  GlobalVariableSet("goSELL",1);
               }
         Sky_BufferH[i]=high - (high - low)*SkyCh / 100;
         Sky_BufferL[i]=low  + (high - low)*SkyCh / 100;
      }
      manageAlerts();
      return(0);
   }      
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      int z = iBarShift(NULL,timeFrame,Time[i+1]);
      
         Sky_BufferH[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSP,SkyCh,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,2,y);
         Sky_BufferL[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSP,SkyCh,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,3,y);
         val1[i]        = EMPTY_VALUE;
         val2[i]        = EMPTY_VALUE;
         if (y!=z)
         {
               val1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSP,SkyCh,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
               val2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSP,SkyCh,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,1,y);
         }

         //
         //
         //
         //
         //
         
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
               {
                  Sky_BufferH[i+k] = Sky_BufferH[i] + (Sky_BufferH[i+n] - Sky_BufferH[i])*k/n;
                  Sky_BufferL[i+k] = Sky_BufferL[i] + (Sky_BufferL[i+n] - Sky_BufferL[i])*k/n;
               }                  
   }                        
   return(0);   
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (val1[whichBar] != EMPTY_VALUE || val2[whichBar] != EMPTY_VALUE)
      {
         if (val1[whichBar] != EMPTY_VALUE) doAlert(whichBar,"up");
         if (val2[whichBar] != EMPTY_VALUE) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" lukas1 signal changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"  lukas1 "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}